/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlvorschlag.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="LISTENVERBINDUNG.Bezeichnung",
     query="SELECT o FROM Listenverbindung o WHERE o.bezeichnung=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "LISTENVERBINDUNG")
// @javax.persistence.IdClass(ListenverbindungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Listenverbindung
extends AbstractListenverbindung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Listenverbindung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Listenverbindung(Listenverbindung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "listenverbindung_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Listenverbindung")
    @javax.persistence.TableGenerator(name = "Listenverbindung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Listenverbindung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ListenverbindungPK pkCache;

  @Override
  public ListenverbindungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ListenverbindungPK(getId());
    }

    return pkCache;
  }

  public static <E extends Listenverbindung> java.util.Map<ListenverbindungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ListenverbindungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Listenverbindung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBezeichnung = false;
  


          hasChangedListesByListenverbindung = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEZEICHNUNG", nullable = ListenverbindungConstants.BEZEICHNUNG_NULLABLE, length=ListenverbindungConstants.BEZEICHNUNG_MAX_LENGTH)
        
  protected java.lang.String bezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBezeichnung = false;

  public boolean hasChangedBezeichnung(){
    return hasChangedBezeichnung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBezeichnung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBezeichnung;
  
  /**
   * 
   *
   * getter for LISTENVERBINDUNG.BEZEICHNUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBezeichnung() {
        return bezeichnung;
      }

  /**
   * 
   *
   * setter for LISTENVERBINDUNG.BEZEICHNUNG
   *
   * @param bezeichnung
   */
  @Override   public void setBezeichnung(@javax.annotation.Nullable  java.lang.String bezeichnung) {

       resetTkCache();
                  
                          java.lang.String bezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bezeichnung, ListenverbindungConstants.BEZEICHNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bezeichnung
      , bezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bezeichnung");
      }


             if (!isSeitLadenVeraendertBezeichnung) {
          isSeitLadenVeraendertBezeichnung = thisAttributChanged;
         if (isSeitLadenVeraendertBezeichnung){
           wertNachLadenBezeichnung=this.bezeichnung;
         }
       }
      

       this.bezeichnung = bezeichnungInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu ListesByListenverbindung
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.wahlvorschlag.entity.Liste.class, mappedBy="listenverbindung", fetch=javax.persistence.FetchType.LAZY )
// deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.wahlvorschlag.entity.Liste> listesByListenverbindung;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.wahlvorschlag.entity.Liste> getListesByListenverbindung(){
    if (listesByListenverbindung == null){
      return  java.util.Collections.<de.ivu.elect.business.wahlvorschlag.entity.Liste>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.wahlvorschlag.entity.Liste>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.wahlvorschlag.entity.Liste>unmodifiableSet(this.listesByListenverbindung);
  }

  @javax.persistence.Transient
  private boolean hasChangedListesByListenverbindung = false;

  public boolean hasChangedListesByListenverbindung() {
    return hasChangedListesByListenverbindung;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.wahlvorschlag.entity.Liste
   */
  @Override
  public void addListeByListenverbindung(de.ivu.elect.business.wahlvorschlag.entity.Liste listeByListenverbindung){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (listeByListenverbindung != null){
          if (this.listesByListenverbindung == null) {
            this.listesByListenverbindung = new java.util.HashSet<>();
          }

          boolean isChanged = this.listesByListenverbindung.add(listeByListenverbindung);

          if(!hasChangedListesByListenverbindung) {
            hasChangedListesByListenverbindung =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          listeByListenverbindung.setListenverbindung(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.wahlvorschlag.entity.Liste
   */
  @Override
  public void removeListeByListenverbindung(de.ivu.elect.business.wahlvorschlag.entity.Liste listeByListenverbindung){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (listeByListenverbindung != null){
          if (this.listesByListenverbindung != null) {
            boolean isChanged = this.listesByListenverbindung.remove(listeByListenverbindung);

            if(!hasChangedListesByListenverbindung) {
              hasChangedListesByListenverbindung =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          listeByListenverbindung.setListenverbindung(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.wahlvorschlag.entity.Liste
  */
   @Override
   public void removeAllListeByListenverbindungs(){
     java.util.Set<de.ivu.elect.business.wahlvorschlag.entity.Liste> toRemove = new java.util.HashSet<>(getListesByListenverbindung());

     for (   de.ivu.elect.business.wahlvorschlag.entity.Liste entity:toRemove){
       removeListeByListenverbindung(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Listenverbindung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Listenverbindung other){
                             other.bezeichnung = this.bezeichnung;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Listenverbindung.class)){
        copyEntityAttributesUsingSetter((Listenverbindung) other.castTo(Listenverbindung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Listenverbindung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Listenverbindung other){
               other.setBezeichnung(this.bezeichnung);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Listenverbindung other){
                       if (hasChangedBezeichnung) {
        other.setBezeichnung(this.bezeichnung);
      }
             }





    @javax.persistence.Transient
    private transient ListenverbindungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ListenverbindungTK getListenverbindungTK(){
    if (tkCache==null) {
    tkCache = new ListenverbindungTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getListenverbindungTK();
    }

  @Override
  public ListenverbindungUK getUk(){
    return getListenverbindungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Listenverbindung.class;
  }

public ListenverbindungUK getListenverbindungUK(){

   return  new ListenverbindungUK(



  );
}

  @javax.persistence.Transient
  private transient ListenverbindungProperties properties;

  public ListenverbindungProperties getProperties(){
    if (properties == null) {
      properties = new ListenverbindungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ListenverbindungProperties getListenverbindungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ListenverbindungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(ListenverbindungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ListenverbindungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL);

        bezeichnung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBezeichnung) {
      result.put(ListenverbindungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBezeichnung , bezeichnung));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBezeichnung = false;
      wertNachLadenBezeichnung = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "LISTENVERBINDUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Listenverbindung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ListenverbindungConstants.BEZEICHNUNG_MAX_LENGTH ,  bezeichnung, this, ListenverbindungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
